/* $Id: csg.h,v 1.3 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: csg.h,v $
Revision 1.3  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.2  1995/08/03 18:45:43  sean
Constructive Solid Geometry

*/
#ifndef CSG_H
#define CSG_H

#include "surfaces.h"
#include "shader.h"

class Interval {
  public:
        v2 *ival;
	Surface *s_in, *sout;
	Interval *next;
	Interval(Surface *surf1, Surface *surf2, v2 *surf_interval);
	~Interval();
	void print();
};	

typedef enum { csg_op_union, csg_op_intersection, csg_op_not, csg_op_is} 
	csg_op_tag;
typedef enum { csg_prim, csg_complex } csg_node_tag;

class CSGnode {
  public:
	csg_op_tag op_tag;
	csg_node_tag ltag, rtag;
	union {
	        CSGnode *csg_left;
	        Surface *surf_left;
	};
	
	union {
		CSGnode *csg_right;
		Surface *surf_right;
	};
	CSGnode(csg_op_tag, csg_node_tag, csg_node_tag,
			void *leftin, void *rightin);
	
	void print(int);
};

class Scene {
  SurfaceNode *root, *current;
 public:
  CSGnode *csgnode;
  Scene();
  v3 * Testray(ray *);
  real Feeler(ray *);
  void Print();
};

Interval *interval(CSGnode *node, ray *r);
Interval *csg_and(Interval *, Interval *);
Interval *csg_or(Interval *, Interval *);
Interval *csg_not(Interval *);

#endif
  
