/* $Id: lights.h,v 1.2 1995/08/03 18:45:43 sean Exp sean $ */
/*
$Log: lights.h,v $
Revision 1.2  1995/08/03 18:45:43  sean
Simple

*/
#ifndef LIGHTS_H
#define LIGHTS_H

#include "matrix.h"

typedef enum {pointTag, directionTag} lightSourceTag;

class LightSource
{
  lightSourceTag sourceTag;
  union {
    v3 *point;
    v3 *direction;
  };
  real intensity;
 public:
  v3 *spectrum;
  LightSource(lightSourceTag, v3, real, v3);
  v3 * Normal(v3 *);
  void Print();
};
class LightNode;
class LightNode
{
 public:
  LightSource *light;
  LightNode *next;
};

class LightList;
class LightList
{
  LightNode *root, *current;
 public:
  LightList(LightList *);
  void Add(LightSource *);
  LightSource * First();
  LightSource * Next();
  void Print();
};

#endif




