/* $Id: main.cc,v 1.6 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: main.cc,v $
Revision 1.6  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.5  1995/08/03 18:45:43  sean
some command line options, need more

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "mainloop.h"
#include "matrix.h"
#include "globalsreal.h"

void Initialize(void);
void usage(void);

main(int argc, char *argv[])
{
  int arg_count;
  real a1, a2, a3;
  char rastername[40];
  SCREEN_WIDTH = 64;
  SCREEN_HEIGHT = 64;
  MAGNIFICATION = 1.0;
  AMBIENT = v3(0.34, 0.34, 0.34);
  CAMERA_ORIGIN = v3(0.0, 0.0, -6.3);
  WORLD_TRANSFORM = m3(1., 0., 0., 0., 1., 0., 0., 0., 1.);
  HCOUNT = VCOUNT = 1;
  HCELL = VCELL = 0;
  
  if (argc < 2) 
	usage();
  else
    {
	arg_count = 1;
	while(arg_count < (argc))
	{
		//printf("> %d  \n",arg_count);
		if (strcmp(argv[arg_count],"-res") == 0)
		{
			arg_count++;
			SCREEN_WIDTH = atoi(argv[arg_count]);
			arg_count++;
			SCREEN_HEIGHT = atoi(argv[arg_count]);
			arg_count++;
			printf("Resolution: %d x %d \n", SCREEN_WIDTH,
				SCREEN_HEIGHT);
		} else if (strcmp(argv[arg_count],"-mag") == 0) {
			arg_count++;
			a1 = atof(argv[arg_count++]);
			MAGNIFICATION = a1;
			printf("Magnification: %3.2f \n", MAGNIFICATION);
		} else if (strcmp(argv[arg_count],"-cam") == 0) {
			arg_count++;
			a1 = atof(argv[arg_count++]);
			a2 = atof(argv[arg_count++]);
			a3 = atof(argv[arg_count++]);
  			CAMERA_ORIGIN = v3(a1, a2, a3);
			printf("Camera at: ");
			CAMERA_ORIGIN.print();	
			printf("\n");
 		} else if (strcmp(argv[arg_count],"-tm") == 0) {
                        arg_count++;
			a1 = atof(argv[arg_count++]);
			a2 = atof(argv[arg_count++]);
			a3 = atof(argv[arg_count++]);
                        WORLD_TRANSFORM =
                                m3(cos(a1) , - sin(a1), 0.,
				   sin(a1), cos(a1), 0.,
				   0., 0., 1.0)
			*	m3(cos(a2), 0.,  - sin(a2),
				    0., 1., 0., 
                                   sin(a2), 0., cos(a2))
			*	m3(1., 0., 0.,
				    0., cos(a3) , - sin(a3),
                                   0., sin(a3), cos(a3));

		} else if (strcmp(argv[arg_count], "-cell") == 0 ) {
			arg_count++;
			HCOUNT = atoi(argv[arg_count++]);
			VCOUNT = atoi(argv[arg_count++]);
			HCELL = atoi(argv[arg_count++]);
			VCELL = atoi(argv[arg_count++]);
		} else {
			strcpy(rastername, argv[arg_count++]);
		}
	} //while
	if ((Rasterfile = fopen(rastername, "w")) == NULL)
    	{
		fprintf(stderr, "Could not open file %s for writing\n", argv[1]);
    	} else {
    		Initialize();
	}
   } // if usage
}

void Initialize()
{
  DrawScene();
  fclose(Rasterfile);
}

void usage()
{
	printf("Usage: dirt [-res xres yres] \\ \n");
	printf("	[-cam xcor ycor zcor] \\ \n");
	printf("	[-mag magnification] \\ \n");
	printf("	[-tm xy xy yz] \\ \n");
	printf("	[-cell hcount vcount hcell vcell] \\ \n");
	printf("	filename \n");
}
