/* $Id: surfaces.h,v 1.6 1997/04/12 22:32:46 sean Exp sean $ */
/*
$Log: surfaces.h,v $
Revision 1.6  1997/04/12 22:32:46  sean
*** empty log message ***

Revision 1.5  1995/08/03 18:45:43  sean
spheres and planes.  Need to add more prims.

*/
#ifndef SURFACES_H
#define SURFACES_H
#include "matrix.h"
#include "ray.h"
#include "surfprops.h"

class Sphere {
  v3 *center, *pole, *equator, *spxse;
  real radius, radius_pow_2;
 public:
  Sphere(v3 newcenter, real newradius, v3 newpole, v3 newequator); 

  v3 * Normal(v3 *);
  v2 R2(v3);
  v3 R3(v2);
  void Print();
  photon * Testray(ray *);
  v2 *interval(ray *);
};

class Cylinder {
  v3 *center, *axis, *equator, *cxa;
  real radius, rraa, aa, rr;
 public:
  Cylinder(v3 newcenter, v3 newaxis, v3 newequator, real radius);

  v3 * Normal(v3 *);
  v2 R2(v3);
  void Print();
  v2 *interval(ray *);
};

class Plane {
  real a, b, c, d;
 public:
  v3 *origin, *unitnormal, *u, *v;
  Plane(v3, v3, v3);  //origin, r, s
  v3 * Normal(v3 *);
  v2 R2(v3);
  v3 R3(v2);
  void Print();
  photon * Testray(ray *);
  v2 *interval(ray *);
};

class MeshNode;
class MeshNode {
 public:
  char sex;
  int row, col;
  Plane *plane;
  MeshNode *next;
};

class Mesh {
  Plane *baseplane;
  MeshNode *meshlist;
public:
  Mesh( Plane *, PPMrast *);
  int rows, cols;
  v3 * Normal(v3 *);
  v2 R2(v3);
  v3 R3(v2);
  void Print();
  v2 *interval(ray *);
};
 
typedef enum { Sphere_tag, Plane_tag, Cylinder_tag, Mesh_tag  } surfaceTag;
class Surface {
  surfaceTag tag;
  union {
    Sphere *sphere;
    Plane *plane;
    Cylinder *cylinder;
    Mesh *mesh;
  };
 public:
  Surface( surfaceTag, void *, SurfProps *);  //Have to figure a better way
  v3 * Normal(v3 *);
  SurfProps *surface_props;
  v3 color (v2);
  photon * Testray(ray *);
  v2 R2(v3);
  void Print();
  v2 *interval(ray *);
};

class SurfaceNode;
class SurfaceNode {
 public:
  Surface *surface;
  SurfaceNode *next;
};

#endif
